'''
Human Alliance WCS:Python Race Coded By: J3ff Hoogland
'''
import wcs, es, random, playerlib, gamethread, HumanAllianceConfig
from wcs import wcs
from HumanAllianceConfig import *
#Our Race's Name - This is not needed I just feel it makes things look cleaner
RaceName = 'Human Alliance'
wcs.Race(RaceName).registerSkill('Invisibility', Invisibility_MaxRanks, Invisibility_LevelInterval, 'Makes you partially invisible.')
wcs.Race(RaceName).registerSkill('Devotion', Devotion_MaxRanks, Devotion_LevelInterval, 'Gives you additional health each round.')
wcs.Race(RaceName).registerSkill('Bash', Bash_MaxRanks, Bash_LevelInterval, 'Have a chance to stun the person you hit with an attack.')
wcs.Race(RaceName).registerUltimate('Avatar', Avatar_RequiredLevel, Avatar_MaxRanks, Avatar_LevelInterval, 'Hold down your ultimate key to get stronger for a short time.')

def player_spawn(event_var):
	userid = int(event_var['userid'])
	if not wcs.GetLevel(userid, RaceName, 'Invisibility'):
		wcs.Command(userid).Color(alpha=255)
	invisi(userid)
	devo = wcs.GetLevel(userid, RaceName, 'Devotion')*Devotion_Amount
	if devo:
		wcs.Command(userid).HealthAdd(devo)
		es.tell(userid, '#multi', '#lightgreenDevotion Aura #default- #greenYou have %s bonus health.'%(devo))
		wcs.Effect().Misc1(userid, 1)
	wcs.Command(userid).UpdateDict('avatar', 0)
def item_pickup(event_var):
	userid = int(event_var['userid'])
	ava = wcs.Command(userid).ReturnDict('avatar')
	if not ava:
		invisi(userid)
def player_hurt(event_var):
	userid = int(event_var['userid'])
	attacker = int(event_var['attacker'])
	if attacker:
		if event_var['dmg_health']:
			damage = int(event_var['dmg_health'])
		else:
			damage = 0
		bash = wcs.GetLevel(attacker, RaceName, 'Bash')*Bash_Percent
		if bash:
			if bash >= random.randint(1,100):
				wcs.Effect().Beam1(userid, attacker, 1.5, 0, 0, 255)
				wcs.Command(userid).Freeze(4)
				es.tell(attacker, '#multi', '#lightgreenBash #default- #greenYou have stunned %s.'%(event_var['es_username']))
		ava = wcs.GetLevel(attacker, RaceName, 'Avatar')
		if ava:
			state = wcs.Command(attacker).ReturnDict('avatar')
			if state:
				wcs.Command(userid).Damage(damage*.3,32,attacker)
def player_ultimate_on(event_var):
	userid = int(event_var['userid'])
	ava = wcs.GetLevel(userid, RaceName, 'Avatar')*Avatar_Duration
	if ava and not wcs.Command(userid).ReturnDict('avatar'):
		es.tell(userid, '#multi', '#lightgreenAvatar #default- #greenYou have increased power for the next %s seconds.'%ava)
		wcs.Command(userid).UpdateDict('avatar', 1)
		wcs.Command(userid).HealthAdd(100)
		wcs.Command(userid).Color(blue=255)
		wcs.Effect().Ring1(userid, 50, 2, 0, 50, 255)
		wcs.Command(userid).Delayed(ava, avaoff, userid)
def invisi(userid):
	invis = wcs.GetLevel(userid, RaceName, 'Invisibility')
	if invis:
		wcs.Command(userid).Color(alpha=255-(invis*Invisibility_Rating+90))
def avaoff(userid):
	state = wcs.Command(userid).ReturnDict('avatar')
	if state:
		es.tell(userid, '#multi', '#lightgreenAvatar #default- #greenYour power increase has worn off.')
		wcs.Command(userid).UpdateDict('avatar', 0)
		invisi(userid)
		wcs.Command(userid).SetCoolDown('Avatar', Avatar_CoolDownTimer)
		wcs.Effect().Ring1(userid, 50, 2, 0, 255, 50)
		if playerlib.getPlayer(userid).get('health') >= 101:
			wcs.Command(userid).HealthAdd(-100)
		else:
			wcs.Command(userid).Health(1)
