'''
Warden WCS:Python Race Coded By: J3ff Hoogland
'''
import wcs, es, random, gamethread, playerlib
from wcs import wcs
#Our Race's Name - This is not needed I just feel it makes things look cleaner
RaceName = 'Warden'
wcs.Race(RaceName).registerSkill('Hide', 2, 5, 'You become hard to see when standing still.')
wcs.Race(RaceName).registerSkill('Shadow Strike', 3, 1, 'Your attacks deal extra damage over time.')
wcs.Race(RaceName).registerSkill('Blink', 3, 2, 'Use your ability to jump to the postion you are looking at.(Ability)')
wcs.Race(RaceName).registerSkill('Fan of Knives', 3, 1, 'Use your ability to deal damage to all oppents near you.(Ability2)')
wcs.Race(RaceName).registerUltimate('Avatar of Vengance', 6, 1, 1, 'Creates an avatar that summon\'s spirit allies from near by corpses.')
wcs.Race(RaceName).registerMinLevel(100)
global_deaths = []
def player_ultimate_on(event_var):
	userid = int(event_var['userid'])
	if wcs.GetLevel(userid, RaceName, 'Avatar of Vengance'):
		x,y,z = es.getplayerlocation(userid)
		wcs.Command(userid).SetCoolDown('Avatar of Vengance', 30)
		create_spirit(userid,x,y,z,0,[])
def create_spirit(userid,x,y,z,count,bannedlist):
	if count < 20:
		es.server.queuecmd('est_effect 3 #a 0 sprites/lgtning.vmt %s %s %s %s %s %s %s 40 10 %s %s %s 255'%(x,y,z+100,x,y,z,1,255,255,255))
		es.server.queuecmd('est_effect 10 #a 0 effects/tp_eyefx/tpeye3.vmt %s %s %s 9 0 %s 66 1 0 255 255 255 255 1'%(x,y,z+75,1))
		nearlist = deadnear(x,y,z)
		for loc in bannedlist:
			if loc in nearlist:
				del nearlist[nearlist.index(loc)]
		if len(nearlist):
			post = random.choice(nearlist)
			global global_deaths
			del global_deaths[post]
			bannedlist.append(post)
			spirit_loop(userid,post[0],post[1],post[2]+30,0)
		team = int(es.getplayerteam(userid))
		if team == 2:
			filter = '#ct'
		elif team == 3:
			filter = '#t'
		wcs.Command(userid).Delayed(1,create_spirit,(userid,x,y,z,count+1,bannedlist))
		userlist = wcs.Command(userid).GetNearCoordList(x,y,z,800,800,800,filter)
		if len(userlist):
			target = random.choice(userlist)
			x1,y1,z1 = es.getplayerlocation(target)
			es.server.queuecmd('est_effect 3 #a 0 effects/tp_eyefx/tpeye3.vmt %s %s %s %s %s %s %s 7 3 %s %s %s 180'%(x,y,z+30,x1,y1,z1 + 30,.5,0,0,0))
			wcs.Command(target).Damage(35,32,userid)
def spirit_loop(userid,x,y,z,count):
	if count <= 10:
		wcs.Command(userid).Delayed(.5,spirit_loop,(userid,x,y,z,count+1))
		team = int(es.getplayerteam(userid))
		if team == 2:
			filter = '#ct'
		elif team == 3:
			filter = '#t'
		es.server.queuecmd('est_effect 10 #a 0 sprites/lgtning.vmt %s %s %s %s %s %s 5 0 2 %s %s %s 128 10'%(x,y,z,40,60,.5,255,0,0))
		userlist = wcs.Command(userid).GetNearCoordList(x,y,z,800,800,800,filter)
		if len(userlist):
			target = random.choice(userlist)
			x1,y1,z1 = es.getplayerlocation(target)
			es.server.queuecmd('est_effect 3 #a 0 effects/tp_eyefx/tpeye3.vmt %s %s %s %s %s %s %s 7 3 %s %s %s 180'%(x,y,z,x1,y1,z1 + 30,.5,0,0,0))
			wcs.Command(target).Damage(15,32,userid)
def deadnear(x,y,z):
	nearlist = []
	if wcs.game == 'Counter-Strike: Source' and not wcs.cssdm:
		for player in playerlib.getPlayerList('#all'):
			qx,qy,qz = wcs.Command(player).ReturnDict('death location')
			if qx or qy or qz:
				qx -= x
				qy -= y
				qz -= z
				if abs(qx) <= 1000 and abs(qy) <= 1000 and abs(qz) <= 1000:
					nearlist.append(wcs.Command(player).ReturnDict('death location'))
	elif 'Deathmatch' in game or wcs.cssdm:
		for l in global_deaths:
			qx,qy,qz = l[0],l[1],l[2]
			if qx or qy or qz:
				qx -= x
				qy -= y
				qz -= z
				if abs(qx) <= 1000 and abs(qy) <= 1000 and abs(qz) <= 1000:
					nearlist.append((l[0],l[1],l[2]))
	return nearlist
def player_death(event_var):
	userid = int(event_var['userid'])
	if wcs.game == 'Counter-Strike: Source':
		wcs.Command(userid).UpdateDict('death location', es.getplayerlocation(userid))
	elif 'Deathmatch' in wcs.game:
		global global_deaths
		global_deaths.append(es.getplayerlocation(userid))
def player_hurt(event_var):
	userid = int(event_var['userid'])
	attacker = int(event_var['attacker'])
	if event_var['dmg_health']:
		damage = int(event_var['dmg_health'])
	else:
		damage = 0
	strike = wcs.GetLevel(attacker,RaceName,'Shadow Strike')*10
	if strike >= random.randint(1,100):
		if not wcs.Command(userid).ReturnDict('poisoned'):
			wcs.Effect().Beam1(attacker,userid,1.5,0,255,0)
			wcs.Command(userid).UpdateDict('poisoned',1)
			wcs.Command(userid).SpeedAdd(-.2)
			wcs.Command(userid).Delayed(2,wcs.Command(userid).Damage,(damage/10,32,attacker))
			wcs.Command(userid).Delayed(4,wcs.Command(userid).Damage,(damage/10,32,attacker))
			wcs.Command(userid).Delayed(6,wcs.Command(userid).Damage,(damage/10,32,attacker))
			wcs.Command(userid).Delayed(8,wcs.Command(userid).Damage,(damage/10,32,attacker))
			wcs.Command(userid).Delayed(10,wcs.Command(userid).Damage,(damage/10,32,attacker))
			wcs.Command(userid).Delayed(10,wcs.Command(userid).SpeedAdd,.2)
			wcs.Command(userid).Delayed(10,wcs.Command(userid).UpdateDict,('poisoned',0))
def player_spawn(event_var):
	userid = int(event_var['userid'])
	wcs.Command(userid).UpdateDict('death location', (0,0,0))
	if wcs.GetLevel(userid, RaceName, 'Hide'):
		wcs.Command(userid).UpdateDict('location', es.getplayerlocation(userid))
		if not wcs.Command(userid).ReturnDict('looping'):
			hide_loop(userid)
def player_ability_on(event_var):
	userid = int(event_var['userid'])
	if wcs.GetLevel(userid, RaceName, 'Blink'):
		if not wcs.Command(userid).GetCoolDown('Blink'):
			view = wcs.Command(userid).GetViewCoord()
			#if wcs.Command(userid).GetTeleSafe(view[0],view[1],view[2]):
			wcs.Effect().Smoke(userid)
			es.server.queuecmd('es_xsetpos %s %s %s %s'%(userid, view[0], view[1], view[2]+50))
			wcs.Command(userid).SetCoolDown('Blink',30/wcs.GetLevel(userid, RaceName, 'Blink'))
		else:
			es.tell(userid,'#multi','#lightgreenBlink #default- #greenYou must wait %s more seconds before using this skill again!'%wcs.Command(userid).GetCoolDown('Blink'))
def player_ability_on2(event_var):
	userid = int(event_var['userid'])
	if wcs.GetLevel(userid, RaceName, 'Fan of Knives'):
		if not wcs.Command(userid).GetCoolDown('Fan of Knives'):
			wcs.Effect().Ring3(userid,360,1,128,128,128)
			team = int(es.getplayerteam(userid))
			if team == 2:
				filter = '#ct'
			elif team == 3:
				filter = '#t'
			wcs.Command(userid).SetCoolDown('Fan of Knives',8)
			wcs.Command(userid).Near(360,Knives,filter)
		else:
			es.tell(userid,'#multi','#lightgreenFan of Knives #default- #greenYou must wait %s more seconds before using this skill again!'%wcs.Command(userid).GetCoolDown('Fan of Knives'))
def Knives(userid, attacker):
	wcs.Command(userid).Damage(wcs.GetLevel(attacker, RaceName, 'Fan of Knives')*35,32,attacker)
def hide_loop(userid):
	if es.exists('userid', userid):
		if not playerlib.getPlayer(userid).get('isdead'):
			if wcs.GetLevel(userid, RaceName, 'Hide'):
				wcs.Command(userid).UpdateDict('looping',1)
				location = es.getplayerlocation(userid)
				if location == wcs.Command(userid).ReturnDict('location'):
					wcs.Command(userid).Fade(60/wcs.GetLevel(userid, RaceName, 'Hide'), 1)
				else:
					wcs.Command(userid).Color(alpha=255)
					wcs.Command(userid).UpdateDict('location', location)
				gamethread.delayed(1, hide_loop, userid)
		else:
			wcs.Command(userid).UpdateDict('looping',0)